/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import jp.mosp.common.MosPAction;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.dao.CmCodeDao;
import jp.mosp.common.dto.CmCodeDto;
import jp.mosp.system.vo.CmCodeCardVo;

/**
 * @author yoshida
 *
 */
public class CmCodeCardAction extends MosPAction {
	
	// コマンド
	private static final String	CMD_CODE_CARD_SHOW		= "S2005";	// 表示(追加)
	private static final String	CMD_CODE_CARD_SELECT	= "S2006";	// 表示(選択)
	private static final String	CMD_CODE_CARD_INSERT	= "S2007";	// 登録
	private static final String	CMD_CODE_CARD_UPDATE	= "S2008";	// 更新
																	
	
	/**
	 * コンストラクタ
	 */
	public CmCodeCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_CODE_CARD_SHOW)) {
			// 表示(新規)
			show();
		} else if (cmd.equals(CMD_CODE_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_CODE_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_CODE_CARD_UPDATE)) {
			// 更新
			update();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new CmCodeCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		CmCodeCardVo vo = (CmCodeCardVo)getVo();
		// コード区分プルダウンリスト作成
		vo.aryPltTId = getCodeArray();
	}
	
	@Override
	protected void show() {
		CmCodeCardVo vo = (CmCodeCardVo)getVo();
		vo.setPltTId("");
		vo.setTxtTCode("");
		vo.setTxtTName("");
		vo.setTxtIndex("");
		vo.setPltDelete("");
		vo.setMode(CmCodeCardVo.MODE_INSERT);
	}
	
	@Override
	protected void select() throws Exception {
		CmCodeCardVo vo = (CmCodeCardVo)getVo();
		// データの取得
		CmCodeDto dto = part().cmcode().getCmCodeDao().findForKey(key1, key2);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		vo.setMode(CmCodeCardVo.MODE_UPDATE);
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		CmCodeCardVo vo = (CmCodeCardVo)getVo();
		vo.setParams(request);
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		// パラメータの妥当性確認
		vo.validate(true);
		// DTOの準備
		CmCodeDto dto = new CmCodeDto();
		vo.setDtoFields(dto);
		// DAOの準備
		CmCodeDao dao = part().cmcode().getCmCodeDao();
		// 存在チェック
		chkDuplicate(dao.findForKey(dto.getTId(), dto.getTCode()));
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		CmCodeDto retDto = dao.findForKey(dto.getTId(), dto.getTCode());
		// コミット
		commit();
		// モード設定
		vo.setMode(CmCodeCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		CmCodeDto dto = (CmCodeDto)getSessionDto();
		CmCodeCardVo vo = (CmCodeCardVo)getVo();
		vo.setParams(request);
		// コード区分取得
		vo.setPltTId(dto.getTId());
		// パラメータの妥当性確認
		vo.validate(false);
		// DTOの準備
		vo.setDtoFields(dto);
		// DAOの準備
		CmCodeDao dao = part().cmcode().getCmCodeDao();
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(dto.getTId(), dto.getTCode()));
		// データの更新
		dao.update(dto);
		// DTOの再取得
		CmCodeDto retDto = dao.findForKey(dto.getTId(), dto.getTCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(CmCodeCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
}
